using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    //public enum AttachmentType
    //{
    //    Avatar=1,//ͷ
    //    Resume=2,//
    //    GCP=3,//GCP֤
    //    MedicalLicence=4,//ҽʦʸ֤
    //    PracticeCertificate=5,//ִҵʸ֤
    //    LargeEquipmentWorkingCertificate=6,//еϸ֤
    //    HighestDegreeCertificate=7//ѧ֤
    //}
    [Table("Attachment")]
    public partial class Attachment : Entity, IAuditAdd
    {

        [JsonIgnore]
        public Doctor Doctor { get; set; }

        public Guid DoctorId { get; set; }
        public string Type { get; set; }
        public bool IsOfficial { get; set; } = false;
        public string Path { get; set; } = string.Empty;
        public string Code { get; set; } = string.Empty;
        public DateTime? ExpiryDate { get; set; }
        public string FileName { get; set; } = string.Empty;
        public DateTime CreateTime { get; set; }
        public Guid CreateUserId { get; set; } = Guid.Empty;
        //language=1 ģ 2ΪӢ
        public int Language { get; set; } = 0;

        //public Guid CreateUserId { get; set; } = Guid.Empty;
        //public DateTime? CreateTime { get; set; }
    }
}
